# 概括

[![badge](https://img.shields.io/endpoint.svg?url=https%3A%2F%2Fgezf7g7pd5.execute-api.ap-northeast-1.amazonaws.com%2Fdefault%2Fsource_up_to_date%3Fowner%3Derg-lang%26repos%3Derg%26ref%3Dmain%26path%3Ddoc/EN/syntax/SUMMARY.md%26commit_hash%3D2ce482b1c8407332b3b74f4c3e5596f373f9a657)](https://gezf7g7pd5.execute-api.ap-northeast-1.amazonaws.com/default/source_up_to_date?owner=erg-lang&repos=erg&ref=main&path=doc/EN/syntax/SUMMARY.md&commit_hash=2ce482b1c8407332b3b74f4c3e5596f373f9a657)

- [基础](./00_basic.md)
- [文字](./01_literal.md)
- [名称](02_name.md)
- [声明](./03_declaration.md)
- [函数](./04_function.md)
- [内置函数](./05_builtin_funcs.md)
- [操作员](./06_operator.md)
- [副作用](./07_side_effect.md)
- [程序](./08_procedure.md)
- [内置程序](./09_builtin_procs.md)
- [数组](./10_array.md)
- [元组](./11_tuple.md)
- [字典](./12_dict.md)
- [记录](./13_record.md)
- [设置](./14_set.md)
- [类型](./15_type.md)
  - [类型系统](./type/01_type_system.md)
  - [基础](./type/02_basic.md)
  - [特质](./type/03_trait.md)
  - [类](./type/04_class.md)
  - [继承](./type/05_inheritance.md)
  - [NST 与 SST](./type/06_nst_vs_sst.md)
  - [补丁](./type/07_patch.md)
  - [值类型](./type/08_value.md)
  - [属性类型](./type/09_attributive.md)
  - [间隔类型](./type/10_interval.md)
  - [枚举类型](./type/11_enum.md)
  - [细化类型](./type/12_refinement.md)
  - [代数类型](./type/13_algebraic.md)
  - [依赖类型](./type/14_dependent.md)
  - [量化类型](./type/15_quantified.md)
  - [子类型](./type/16_subtyping.md)
  - [类型转换](./type/17_type_casting.md)
  - [可变类型](./type/18_mut.md)
  - [高级](./type/advanced.md)
    - [默认参数](./type/advanced/default_param.md)
    - [类型擦除](./type/advanced/erasure.md)
    - [存在](./type/advanced/existential.md)
    - [GADTs](./type/advanced/GADTs.md)
    - [关键字参数](./type/advanced/keyword_param.md)
    - [种类](./type/advanced/kind.md)
    - [标记特征](./type/advanced/marker_trait.md)
    - [可变结构](./type/advanced/mut_struct.md)
    - [幻象类型](./type/advanced/phantom.md)
    - [投影类型](./type/advanced/projection.md)
    - [量化依赖类型](./type/advanced/quantified_dependent.md)
    - [共享](./type/advanced/shared.md)
- [迭代器](./16_iterator.md)
- [可变性](./17_mutability.md)
- [所有权](./18_ownership.md)
- [可见性](./19_visibility.md)
- [命名规则](20_naming_rule.md)
- [Lambda](./21_lambda.md)
- [子程序](./22_subroutine.md)
- [关闭](./23_closure.md)
- [模块](./24_module.md)
- [对象系统](./25_object_system.md)
- [模式匹配](./26_pattern_matching.md)
- [理解](./27_comprehension.md)
- [扩展语法](./28_spread_syntax.md)
- [装饰器](./29_decorator.md)
- [错误处理](./30_error_handling.md)
- [管道](./31_pipeline.md)
- [与 Python 集成](./32_integration_with_python.md)
- [包系统](./33_package_system.md)
- [发电机](./34_generator.md)
- [索引](./indexes.md)